import egglib

egglib.io.make_vcf_index('LG15.vcf')
vcf = egglib.io.VcfParser('LG15.vcf')

labels = list('aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa\
aaaaaaaaaaaaaaaaaaaaaaaavvvvvvvvvvvvvvvvvvvvvvvvvv\
vvvvvvvvvvvvvvaavvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv\
vv')

struct = egglib.struct_from_iterable(labels)

cs = egglib.stats.ComputeStats(struct=struct)
cs.add_stats('lseff', 'thetaW', 'D', 'FstWC')


sld = vcf.slider(4000, 500, start=2100000, max_missing=10)

with open('stats.txt', 'w') as f:
    f.write('midpoint lseff thetaW D FstWC\n')
    for win in sld:
        f.write('{0} {1[lseff]} {1[thetaW]} {1[D]} {1[FstWC]}\n'.format(
            sum(win.bounds)/2, cs.process_sites(win)))
