import egglib

# import data as an Align object
aln = egglib.io.from_genepop('dataset.gen')
print(f'`{aln.title}` {aln.ns} {aln.ls}')

# compute stats with default structure
cs = egglib.stats.ComputeStats()
cs.add_stats('FstWC', 'Gst', 'Dj', 'He', 'Aing')
struct1 = egglib.struct_from_labels(aln, lvl_pop=0, lvl_indiv=1)
cs.configure(struct=struct1)
print(cs.process_align(aln))

# compute stats with inferred structure
for K in range(2, 7):
    with open(f'clusters-K{K}.txt') as f:
        struct2 = egglib.struct_from_iterable(f, function=str.strip)
    cs.configure(struct=struct2)
    print(cs.process_align(aln))
