import egglib

cs = egglib.stats.ComputeStats(multi_hits=True)
cs.add_stats('S', 'eta', 'Pi', 'D', 'lseff', 'thetaW')

aln = egglib.io.from_fasta('test.fas', alphabet=egglib.alphabets.DNA)
print('whole gene:', cs.process_align(aln))

bounds = [(850, 1300), (1670, 1930), (2450, 2670), (3870, 4100), (4510, 5000)]
rf = egglib.tools.ReadingFrame(bounds)
bases = [b for codon in rf.iter_codons() for b in codon]
print('cds:', cs.process_align(aln.extract(bases)))
aln.to_codons(rf)
print('codons:', cs.process_align(aln))

prot = egglib.tools.translate(aln)
print('protein:', cs.process_align(prot))

cd = egglib.stats.CodingDiversity(aln, raise_stop=True, multiple_alleles=True, multiple_hits=True)
print('synonymous sites:', cs.process_sites(cd.sites_S))
print('non-synonymous sites:', cs.process_sites(cd.sites_NS))


print(cs.process_sites(cd.sites_S)['thetaW'] / cd.num_sites_S)
print(cs.process_sites(cd.sites_NS)['thetaW'] / cd.num_sites_NS)
