from matplotlib import pyplot

L = []
W = []

with open('results.txt') as f:
    for line in f:
        name, t, w = line.split()
        L.append(float(t))
        W.append(float(w))


fig, (ax1, ax2) = pyplot.subplots(1,2)
fig.set_figheight(fig.get_figheight()*1)
fig.set_figwidth(fig.get_figwidth()*2)

ax1.hist(L, bins=20, density=True, color='0.5', ec='w')
ax1.set_ylabel('Density').set_size(15)
ax1.set_yticks([])
ax1.set_xlabel('Tree length').set_size(15)

ax2.hist(W, bins=20, density=True, color='0.5', ec='w')
ax2.set_ylabel('Density').set_size(15)
ax2.set_yticks([])
ax2.set_xlabel('$\omega$').set_size(15)

fig.savefig('plot.png', transparent=True)
