import egglib, glob, os

with open('results.txt', 'w') as f:
    for fname in sorted(glob.glob('cds/*.fas')):
        print(fname)
        cds = egglib.io.from_fasta(fname, alphabet=egglib.alphabets.DNA, cls=egglib.Container)
        cds.to_codons()
        prot = egglib.tools.translate(cds)
        aln_p = egglib.wrappers.muscle(prot)
        aln = egglib.tools.backalign(cds, aln_p)
        tree, stats = egglib.wrappers.phyml(aln, model='HKY85')
        L = stats['size']
        res = egglib.wrappers.codeml(aln, tree, 'M0')
        w = res['omega']
        f.write(f'{os.path.basename(fname)} {L} {w}\n')
